function varargout = FT_properties(varargin)
% FT_PROPERTIES M-file for FT_properties.fig
%      FT_PROPERTIES, by itself, creates a new FT_PROPERTIES or raises the existing
%      singleton*.
%
%      H = FT_PROPERTIES returns the handle to a new FT_PROPERTIES or the handle to
%      the existing singleton*.
%
%      FT_PROPERTIES('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FT_PROPERTIES.M with the given input arguments.
%
%      FT_PROPERTIES('Property','Value',...) creates a new FT_PROPERTIES or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FT_properties_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FT_properties_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to close FT_properties

% Last Modified by GUIDE v2.5 22-May-2003 14:08:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @FT_properties_OpeningFcn, ...
                   'gui_OutputFcn',  @FT_properties_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FT_properties is made visible.
function FT_properties_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FT_properties (see VARARGIN)

% Choose default command line output for FT_properties
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes FT_properties wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FT_properties_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% creating background and university arm
he=imread('p1.jpg');
axes(handles.axes1)
image(he);
e=imread('p2.jpg');
axes(handles.axes2)
image(e);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%######################################################################

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

%##########################################################################

% --- Executes during object creation, after setting all properties.
function signal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to signal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function signal_Callback(hObject, eventdata, handles)
% hObject    handle to signal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of signal as text
%        str2double(get(hObject,'String')) returns contents of signal as a double

%########################################################################

% --- Executes on button press in close.
function close_Callback(hObject, eventdata, handles)
% hObject    handle to close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%########################################################################

% --- Executes on button press in plot.
function plot_Callback(hObject, eventdata, handles)
% hObject    handle to plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File name : FT_properties.m
% Title : Symmetry Properties of the Fourier Transform
% Ref : Discrete-Time signal processing,(oppenheim).
% Page : 53, Table.2-1
% Encoded in MATLAB by: M.R.Edalatzadeh, ID 81613093
% Date : 31/1/82
% Aim : Representation  Properties  of Fourier Transform
% input : input signal samples
 
global x x1 p n a X 
x1=get(handles.signal,'string');           % reading the signal
x=str2num(x1);
val=get(handles.popupmenu1,'value');       % select a  FT property from table
switch val
    case 1
        property1;
        %set(handles.plot,'callback',property1)
    case 2
        property2;
        %set(handles.plot,'callback',property2)
    case 3
        property3;
        %set(handles.plot,'callback',property3)
    case 4
        property4;
        %set(handles.plot,'callback',property4)
    case 5
        property5;
        %set(handles.plot,'callback',property5)
    case 6
        property6;
        %set(handles.plot,'callback',property6)
    case 7
        property7;
        %set(handles.plot,'callback',property7)
    case 8
        property8;
        %set(handles.plot,'callback',property8)
    case 9
        property9;
        %set(handles.plot,'callback',property9)
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%##########################################################################

% --- Executes on button press in demo.
function demo_Callback(hObject, eventdata, handles)
% hObject    handle to demo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 clear global x;
val=get(handles.popupmenu1,'value');       % select a  FT property from table
switch val
    case 1
        property1;
        %set(handles.demo,'callback',property1)
    case 2
        property2;
        %set(handles.demo,'callback',property2)
    case 3
        property3;
        %set(handles.demo,'callback',property3)
    case 4
        property4;
        %set(handles.demo,'callback',property4)
    case 5
        property5;
        %set(handles.demo,'callback',property5)
    case 6
        property6;
        %set(handles.demo,'callback',property6)
    case 7
        property7;
        %set(handles.demo,'callback',property7)
    case 8
        property8;
        %set(handles.demo,'callback',property8)
    case 9
        property9;
        %set(handles.demo,'callback',property9)
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%########################################################################

% --- Executes on button press in help.
function help_Callback(hObject, eventdata, handles)
% hObject    handle to help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%########################################################################