function varargout = Demo(varargin)
% DEMO M-file for Demo.fig
%      DEMO, by itself, creates a new DEMO or raises the existing
%      singleton*.
%
%      H = DEMO returns the handle to a new DEMO or the handle to
%      the existing singleton*.
%
%      DEMO('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEMO.M with the given input arguments.
%
%      DEMO('Property','Value',...) creates a new DEMO or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Demo_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Demo_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Demo

% Last Modified by GUIDE v2.5 17-Apr-2003 00:08:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Demo_OpeningFcn, ...
                   'gui_OutputFcn',  @Demo_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Demo is made visible.
function Demo_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Demo (see VARARGIN)

% Choose default command line output for Demo
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Demo wait for user response (see UIRESUME)
% uiwait(handles.figure1);


xD=[1,1,1,1,1,1];
xi=str2num(get(handles.t1,'string'));
if length(xi)==0
    x=xD;
else
    x=xi;
end
%%%%%definition of upsample rate
pD=2;
pin=str2num(get(handles.t2,'string'));
if length(pin)==0
    p=pD;
else
    p=pin;
end
%%%%%definition of upsampled and interpolated signals
y=zeros(1,p*length(x)-1);
for k=0:(length(x)-1)
    y(p*k+1)=x(k+1);
end
if length(y)<=256
    lf=512;
else
    lf=pow2(nextpow2(length(y)));
end
yf=fft(y,lf);
w=(0:1:lf-1)/lf;
xf=fft(x,lf);
h=bartlett(2*p+1);
z=conv(y,h);
zf=fft(z,lf);
%%%%%presentation of upsampling characteristics

axes(handles.a2)
plot(w,abs(yf),-w,abs(yf),'b');
title('spectrum of upsampled signal');
xlabel('frequency (w) normalized to pi')
axes(handles.a1)
plot(w,abs(xf),-w,abs(xf),'b');
title('spectrum of main signal'); 



% --- Outputs from this function are returned to the command line.
function varargout = Demo_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function t1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to t1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function t1_Callback(hObject, eventdata, handles)
% hObject    handle to t1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of t1 as text
%        str2double(get(hObject,'String')) returns contents of t1 as a double


% --- Executes during object creation, after setting all properties.
function t2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to t2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function t2_Callback(hObject, eventdata, handles)
% hObject    handle to t2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of t2 as text
%        str2double(get(hObject,'String')) returns contents of t2 as a double


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

xD=[1,1,1,1,1,1];
xi=str2num(get(handles.t1,'string'));
if length(xi)==0
    x=xD;
else
    x=xi;
end
%%%%%definition of upsample rate
pD=2;
pin=str2num(get(handles.t2,'string'));
if length(pin)==0
    p=pD;
else
    p=pin;
end
%%%%%definition of upsampled and interpolated signals
y=zeros(1,p*length(x)-1);
for k=0:(length(x)-1)
    y(p*k+1)=x(k+1);
end
if length(y)<=256
    lf=512;
else
    lf=pow2(nextpow2(length(y)));
end
yf=fft(y,lf);
w=(0:1:lf-1)/lf;
xf=fft(x,lf);
h=bartlett(2*p+1);
z=conv(y,h);
zf=fft(z,lf);
%%%%%presentation of upsampling characteristics

axes(handles.a2)
plot(w,abs(yf),-w,abs(yf),'b');
title('spectrum of upsampled signal');
xlabel('frequency (w) normalized to pi')
axes(handles.a1)
plot(w,abs(xf),-w,abs(xf),'b');
title('spectrum of main signal'); 



% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%%%%%definition of main signal
xD=[1,1,1,1,1,1];
xi=str2num(get(handles.t1,'string'));
if length(xi)==0
    x=xD;
else
    x=xi;
end
%%%%%definition of upsample rate
pD=2;
pin=str2num(get(handles.t2,'string'));
if length(pin)==0
    p=pD;
else
    p=pin;
end
%%%%%definition of upsampled and interpolated signals
y=zeros(1,p*length(x)-1);
for k=0:(length(x)-1)
    y(p*k+1)=x(k+1);
end
if length(y)<=256
    lf=512;
else
    lf=pow2(nextpow2(length(y)));
end
yf=fft(y,lf);
w=(0:1:lf-1)/lf;
xf=fft(x,lf);
h=bartlett(2*p+1);
z=conv(y,h);
zf=fft(z,lf);

axes(handles.a2)
stem(y);
title('upsampled signal in time');
axes(handles.a1)
stem(x);
title('main signal in time');


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
xD=[1,1,1,1,1,1];
xi=str2num(get(handles.t1,'string'));
if length(xi)==0
    x=xD;
else
    x=xi;
end
%%%%%definition of upsample rate
pD=2;
pin=str2num(get(handles.t2,'string'));
if length(pin)==0
    p=pD;
else
    p=pin;
end
%%%%%definition of upsampled and interpolated signals
y=zeros(1,p*length(x)-1);
for k=0:(length(x)-1)
    y(p*k+1)=x(k+1);
end
if length(y)<=256
    lf=512;
else
    lf=pow2(nextpow2(length(y)));
end
yf=fft(y,lf);
w=(0:1:lf-1)/lf;
xf=fft(x,lf);
h=bartlett(2*p+1);
z=conv(y,h);
zf=fft(z,lf);



z_chopped_length=length(z)-4;
for temp=1:z_chopped_length
    z_chopped(temp)=z(temp+2);
end


axes(handles.a2)
stem(z_chopped);
title('interpolated signal in time');
axes(handles.a1)
stem(y);
title('upsampled signal in time');



% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

xD=[1,1,1,1,1,1];
xi=str2num(get(handles.t1,'string'));
if length(xi)==0
    x=xD;
else
    x=xi;
end
%%%%%definition of upsample rate
pD=2;
pin=str2num(get(handles.t2,'string'));
if length(pin)==0
    p=pD;
else
    p=pin;
end
%%%%%definition of upsampled and interpolated signals
y=zeros(1,p*length(x)-1);
for k=0:(length(x)-1)
    y(p*k+1)=x(k+1);
end
if length(y)<=256
    lf=512;
else
    lf=pow2(nextpow2(length(y)));
end
yf=fft(y,lf);
w=(0:1:lf-1)/lf;
xf=fft(x,lf);
h=bartlett(2*p+1);
z=conv(y,h);
zf=fft(z,lf);

axes(handles.a2)
plot(w,abs(zf),-w,abs(zf),'b');
title('spectrum of interpolated signal');
xlabel('frequency (w) normalized to pi')
axes(handles.a1)
plot(w,abs(yf),-w,abs(yf),'b');
title('spectrum of upsampled signal');



% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

CLOSE;


% --------------------------------------------------------------------
function FILE_Callback(hObject, eventdata, handles)
% hObject    handle to FILE (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function new_Callback(hObject, eventdata, handles)
% hObject    handle to new (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function close_Callback(hObject, eventdata, handles)
% hObject    handle to close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function HELP_Callback(hObject, eventdata, handles)
% hObject    handle to HELP (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function demo_Callback(hObject, eventdata, handles)
% hObject    handle to demo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


