% &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
% File Name : yyyy.m
% Titel : spectral  Estimation for Nonstationary Discrete signals by peridogram
% REF : DSP - Oppenheim
% Page 734-736 fig 11.19
% Encoded & editted in Mathlab GUI by : Ahmad.Yaghooby
% Date : 8.2.82
% Aim : discuss in peridogram estimation & related paramters
% Master : Dr.Kahaei
% Student : Ahmad Yaghooby(81613141)
% &&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

function varargout = yyyy(varargin)
% YYYY M-file for yyyy.fig
%      YYYY, by itself, creates a new YYYY or raises the existing
%      singleton*.
%
%      H = YYYY returns the handle to a new YYYY or the handle to
%      the existing singleton*.
%
%      YYYY('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in YYYY.M with the given input arguments.
%
%      YYYY('Property','Value',...) creates a new YYYY or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before yyyy_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to yyyy_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help yyyy

% Last Modified by GUIDE v2.5 01-Jun-2003 15:15:49

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @yyyy_OpeningFcn, ...
                   'gui_OutputFcn',  @yyyy_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before yyyy is made visible.
function yyyy_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to yyyy (see VARARGIN)

% Choose default command line output for yyyy
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes yyyy wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = yyyy_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function windowtype_CreateFcn(hObject, eventdata, handles)
% hObject    handle to windowtype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in windowtype.
function windowtype_Callback(hObject, eventdata, handles)
% hObject    handle to windowtype (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns windowtype contents as cell array
%        contents{get(hObject,'Value')} returns selected item from windowtype


% --- Executes during object creation, after setting all properties.
function ndft_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ndft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function ndft_Callback(hObject, eventdata, handles)
% hObject    handle to ndft (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ndft as text
%        str2double(get(hObject,'String')) returns contents of ndft as a double


% --- Executes during object creation, after setting all properties.
function winlength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to winlength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function winlength_Callback(hObject, eventdata, handles)
% hObject    handle to winlength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of winlength as text
%        str2double(get(hObject,'String')) returns contents of winlength as a double


% --- Executes on button press in plot.
function plot_Callback(hObject, eventdata, handles)
% hObject    handle to plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%  #############################################################3
% INPUT L    default=16
L=str2double(get(handles.winlength,'string'));  %  length of window
% INPUT N    default=1024
N=str2double(get(handles.ndft,'string'));       % N-point DFT
% selection of window type
val=get(handles.windowtype,'value')
% create of normal distribution array - random psedue numbers  
   if val==1 
           window=ones(1,L);
     elseif val==2
           window=bartlett(L);
     elseif val==3
           window=hann(L);
     elseif val==4
           window=hamming(L);
     elseif val==5
           window=blackman(L);
     else
           window=ones(1,L);      % default WINDOW=RECTANGULAR
   end % if no
% random values for x         
x=randn(1,L);
axes(handles.signal);
stem(x)  % plot signal x(n) 
%xlabel(' sample  ( n ) ' )
ylabel(' magnitude ')
axes(handles.window);
stem(window)     % plot  window  w(n) 
xlabel(' sample  ( n ) ' )
ylabel(' magnitude ')

% draw of peridogram 
axes(handles.peridogram);
CLA
outy=PSD(x,N,1,window);
plot(outy)
xlabel(' sample  ( k )  ' )
ylabel(' magnitude ')


% --- Executes on button press in help.
function help_Callback(hObject, eventdata, handles)
% hObject    handle to help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in demo.
function demo_Callback(hObject, eventdata, handles)
% hObject    handle to demo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
 
L=16;     %  length of window
N=1024;   %  N-point DFT
window=ones(1,L);     %  WINDOW=RECTANGULAR   WITH LENGTH=L
set(handles.winlength,'string',L)
set(handles.ndft,'string',N)
set(handles.windowtype,'value',1)
t=0:1:L-1
x=cos(2*pi*t/(L-1));
axes(handles.signal);
stem(x)
%xlabel(' sample ( n ) ' )
ylabel(' magnitude ')
axes(handles.window);
stem(window)
xlabel('  sample ( n ) ' )
ylabel(' magnitude ')
% draw of peridogram 
outy=PSD(x,N,1,window);
axes(handles.peridogram);
plot(outy)
xlabel(' sample ( k )  ' )
ylabel(' magnitude ')


% --- Executes on button press in close.
function close_Callback(hObject, eventdata, handles)
% hObject    handle to close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close


% --- Executes during object creation, after setting all properties.
function help_CreateFcn(hObject, eventdata, handles)
% hObject    handle to help (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes during object creation, after setting all properties.
function listbox1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in listbox1.
function listbox1_Callback(hObject, eventdata, handles)
% hObject    handle to listbox1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox1


% --- Executes during object creation, after setting all properties.
function listbox2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in listbox2.
function listbox2_Callback(hObject, eventdata, handles)
% hObject    handle to listbox2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox2


% --- Executes during object creation, after setting all properties.
function popupmenu2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in popupmenu2.
function popupmenu2_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenu2 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu2


